import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.remote.CapabilityType;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.zaproxy.clientapi.core.*;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Date;


/** Data collection class */
public class WebCrawler
{
	public static void main(String[] args) throws Exception
	{
		if (args.length<1)
		{
			System.err.println("Usage: TestDriver.jar inputFilePath");
			return;
		}
		
		String inputFilePath = args[0];
		BufferedReader in = new BufferedReader(new FileReader(inputFilePath));
		String dirname = new Date().toString().replace(" ", "");
		File dir = new File("/media/Data/Sessions/"+dirname);
		
		dir.mkdir();
		int session = 0;
		String line;
		
		//create segmented file
		while((line=in.readLine())!=null)
		{
			session++;
			BufferedWriter out = new BufferedWriter(new FileWriter("tempURLs.txt"));
			out.write(line+"\r\n");
			int i=0;
			
			//loop through until you hit the specified number of input URLs to visit
			while(true)
			{
				line=in.readLine();
				
				if (line==null)
					break;
				
				if (!(line.startsWith("\t")))
					i++;
				
				out.write(line+"\r\n");
				
				if (i>=15||!in.ready())	//arbitrary cutoff point, but in practice we found 15 works well
					break;
			}
			
			out.close();
			
			//Start ZAP
			Process p =Runtime.getRuntime().exec("java -Xmx512m -XX:PermSize=256M -jar zap.jar org.zaproxy.zap.ZAP %*",null,new File("/home/user/Desktop/ZAP_2.0.0"));
			Thread.sleep(5000);
			
			//ZAP Client API Object
			ClientApi clapi = new ClientApi("localhost",8080,true);
		
			//Proxy Address
			String PROXY="localhost:8080";
	
			//Create Selennium Proxy Object
			org.openqa.selenium.Proxy proxy = new org.openqa.selenium.Proxy();
			proxy.setHttpProxy(PROXY)
			     .setFtpProxy(PROXY)
			     .setSslProxy(PROXY);
			
			System.out.println("Created selennium object..");
			
			//Proxy Configuration
			DesiredCapabilities cap = new DesiredCapabilities();
			cap.setCapability(CapabilityType.PROXY, proxy);
			
			System.out.println("created cap object");
			
			//Create Selennium driver object with the proxy configuration enabled
			WebDriver driver = new FirefoxDriver(cap);
			System.out.println("created webdriver");
			driver.manage().timeouts().pageLoadTimeout(60, java.util.concurrent.TimeUnit.SECONDS);
			
			//This is where the navigation scripts go
			driver = UrlFileProcessor.processUrlFile("tempURLs.txt",driver);
			
			try
			{
				Thread.sleep(30000);
			}
			catch(InterruptedException e)
			{
				System.out.println("Sleep exception...");
			}
			
			driver.quit();
					
			//Save the session data as the timestamp
			System.out.println("saving");
			//clapi.core.saveSession(dirname+"/"+session);
			System.out.println(clapi.core.saveSession(dirname+"/"+session).toString());
			try
			{
				Thread.sleep(5000);
			}
			catch(InterruptedException e)
			{
				System.out.println("Sleep exception...");
			}
			//Kill ZAP
			System.out.println("Killing zap");
			
			//clapi.core.shutdown();
			p.destroy();
		}
		in.close();
	}
}